Bullet Collision Detection & Physics Library: btDeformableLagrangianForce Class Reference

Bullet Collision Detection & Physics Library

Public Types | Public Member Functions | Public Attributes | List of all members
btDeformableLagrangianForce Class Referenceabstract

`#include <btDeformableLagrangianForce.h>`

Inheritance diagram for btDeformableLagrangianForce:
[legend]
Collaboration diagram for btDeformableLagrangianForce:
[legend]

## Public Types
typedef btAlignedObjectArray< btVector3 > | TVStack

## Public Member Functions
| btDeformableLagrangianForce ()
virtual | ~btDeformableLagrangianForce ()
virtual void | addScaledForces (btScalar scale, TVStack &force)=0
virtual void | addScaledDampingForceDifferential (btScalar scale, const TVStack &dv, TVStack &df)=0
virtual void | buildDampingForceDifferentialDiagonal (btScalar scale, TVStack &diagA)=0
virtual void | addScaledElasticForceDifferential (btScalar scale, const TVStack &dx, TVStack &df)=0
virtual void | addScaledExplicitForce (btScalar scale, TVStack &force)=0
virtual void | addScaledDampingForce (btScalar scale, TVStack &force)=0
virtual void | addScaledHessian (btScalar scale)
virtual btDeformableLagrangianForceType | getForceType ()=0
virtual void | reinitialize (bool nodeUpdated)
virtual int | getNumNodes ()
virtual void | addSoftBody (btSoftBody *psb)
virtual void | removeSoftBody (btSoftBody *psb)
virtual void | setIndices (const btAlignedObjectArray< btSoftBody::Node * > *nodes)
virtual btMatrix3x3 | Ds (int id0, int id1, int id2, int id3, const TVStack &dx)
virtual btMatrix3x3 | DsFromVelocity (const btSoftBody::Node *n0, const btSoftBody::Node *n1, const btSoftBody::Node *n2, const btSoftBody::Node *n3)
virtual void | testDerivative ()
virtual void | testHessian ()
virtual double | totalElasticEnergy (btScalar dt)
virtual double | totalDampingEnergy (btScalar dt)
virtual double | totalEnergy (btScalar dt)

## Public Attributes
btAlignedObjectArray< btSoftBody * > | m_softBodies
const btAlignedObjectArray< btSoftBody::Node * > * | m_nodes

## Detailed Description

Definition at line 38 of file btDeformableLagrangianForce.h.

## Member Typedef Documentation

## ◆ TVStack

typedef btAlignedObjectArray<btVector3> btDeformableLagrangianForce::TVStack

Definition at line 41 of file btDeformableLagrangianForce.h.

## Constructor & Destructor Documentation

## ◆ btDeformableLagrangianForce()

btDeformableLagrangianForce::btDeformableLagrangianForce | ( |  | ) |
| inline

Definition at line 45 of file btDeformableLagrangianForce.h.

## ◆ ~btDeformableLagrangianForce()

virtual btDeformableLagrangianForce::~btDeformableLagrangianForce | ( |  | ) |
| inlinevirtual

Definition at line 49 of file btDeformableLagrangianForce.h.

## Member Function Documentation

## ◆ addScaledDampingForce()

virtual void btDeformableLagrangianForce::addScaledDampingForce | ( | btScalar | scale,
|  | TVStack & | force )
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ addScaledDampingForceDifferential()

virtual void btDeformableLagrangianForce::addScaledDampingForceDifferential | ( | btScalar | scale,
|  | const TVStack & | dv,
|  | TVStack & | df )
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ addScaledElasticForceDifferential()

virtual void btDeformableLagrangianForce::addScaledElasticForceDifferential | ( | btScalar | scale,
|  | const TVStack & | dx,
|  | TVStack & | df )
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ addScaledExplicitForce()

virtual void btDeformableLagrangianForce::addScaledExplicitForce | ( | btScalar | scale,
|  | TVStack & | force )
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ addScaledForces()

virtual void btDeformableLagrangianForce::addScaledForces | ( | btScalar | scale,
|  | TVStack & | force )
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ addScaledHessian()

virtual void btDeformableLagrangianForce::addScaledHessian | ( | btScalar | scale | ) |
| inlinevirtual

Reimplemented in btDeformableLinearElasticityForce.

Definition at line 69 of file btDeformableLagrangianForce.h.

## ◆ addSoftBody()

virtual void btDeformableLagrangianForce::addSoftBody | ( | btSoftBody * | psb | ) |
| inlinevirtual

Definition at line 89 of file btDeformableLagrangianForce.h.

## ◆ buildDampingForceDifferentialDiagonal()

virtual void btDeformableLagrangianForce::buildDampingForceDifferentialDiagonal | ( | btScalar | scale,
|  | TVStack & | diagA )
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ Ds()

virtual btMatrix3x3 btDeformableLagrangianForce::Ds | ( | int | id0,
|  | int | id1,
|  | int | id2,
|  | int | id3,
|  | const TVStack & | dx )
| inlinevirtual

Definition at line 105 of file btDeformableLagrangianForce.h.

## ◆ DsFromVelocity()

virtual btMatrix3x3 btDeformableLagrangianForce::DsFromVelocity | ( | const btSoftBody::Node * | n0,
|  | const btSoftBody::Node * | n1,
|  | const btSoftBody::Node * | n2,
|  | const btSoftBody::Node * | n3 )
| inlinevirtual

Definition at line 114 of file btDeformableLagrangianForce.h.

## ◆ getForceType()

virtual btDeformableLagrangianForceType btDeformableLagrangianForce::getForceType | ( |  | ) |
| pure virtual

Implemented in btDeformableCorotatedForce, btDeformableGravityForce, btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

## ◆ getNumNodes()

virtual int btDeformableLagrangianForce::getNumNodes | ( |  | ) |
| inlinevirtual

Definition at line 78 of file btDeformableLagrangianForce.h.

## ◆ reinitialize()

virtual void btDeformableLagrangianForce::reinitialize | ( | bool | nodeUpdated | ) |
| inlinevirtual

Definition at line 73 of file btDeformableLagrangianForce.h.

## ◆ removeSoftBody()

virtual void btDeformableLagrangianForce::removeSoftBody | ( | btSoftBody * | psb | ) |
| inlinevirtual

Definition at line 94 of file btDeformableLagrangianForce.h.

## ◆ setIndices()

virtual void btDeformableLagrangianForce::setIndices | ( | const btAlignedObjectArray< btSoftBody::Node * > * | nodes | ) |
| inlinevirtual

Definition at line 99 of file btDeformableLagrangianForce.h.

## ◆ testDerivative()

virtual void btDeformableLagrangianForce::testDerivative | ( |  | ) |
| inlinevirtual

Definition at line 123 of file btDeformableLagrangianForce.h.

## ◆ testHessian()

virtual void btDeformableLagrangianForce::testHessian | ( |  | ) |
| inlinevirtual

Definition at line 233 of file btDeformableLagrangianForce.h.

## ◆ totalDampingEnergy()

virtual double btDeformableLagrangianForce::totalDampingEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented in btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

Definition at line 361 of file btDeformableLagrangianForce.h.

## ◆ totalElasticEnergy()

virtual double btDeformableLagrangianForce::totalElasticEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented in btDeformableLinearElasticityForce, btDeformableMassSpringForce, btDeformableMousePickingForce, and btDeformableNeoHookeanForce.

Definition at line 355 of file btDeformableLagrangianForce.h.

## ◆ totalEnergy()

virtual double btDeformableLagrangianForce::totalEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented in btDeformableGravityForce.

Definition at line 367 of file btDeformableLagrangianForce.h.

## Member Data Documentation

## ◆ m_nodes

const btAlignedObjectArray<btSoftBody::Node*>* btDeformableLagrangianForce::m_nodes

Definition at line 43 of file btDeformableLagrangianForce.h.

## ◆ m_softBodies

btAlignedObjectArray<btSoftBody*> btDeformableLagrangianForce::m_softBodies

Definition at line 42 of file btDeformableLagrangianForce.h.

The documentation for this class was generated from the following file:

- btDeformableLagrangianForce.h